'interface to determine min and max value for each beater and send it as a sysex to hat
'program change 127 is progamme with following values for each note:
' 36,0,0,8,40
'so velocity 1 gives pulse duration 40 and 127 40 + 127 * 8

'ready fo testing
'remember to delete the status label or give it some use except debugging..



#COMPILE EXE
#RESOURCE "calibrate-hat.pbr"
#OPTION VERSION4
#DIM ALL

#INCLUDE "../winapi/win32api.inc"
#INCLUDE "../winapi/COMMCTRL.INC"
#INCLUDE "../winapi/ComDlg32.inc"


%midichan = 10
%trstyle = %WS_CHILD OR %WS_VISIBLE OR %TBS_NOTICKS OR %WS_TABSTOP

GLOBAL mins() AS BYTE   'this 3 should have same dimensions..
GLOBAL maxs() AS BYTE
GLOBAL notes() AS BYTE
GLOBAL hw AS DWORD
GLOBAL currentfilename AS STRING
GLOBAL changesmade AS DWORD
GLOBAL currentprograms()  AS STRING
GLOBAL hwprog AS DWORD
GLOBAL hmo AS DWORD
GLOBAL LastUploadedProg AS DWORD

FUNCTION PBMAIN () AS LONG

    LOCAL i AS LONG
'    LOCAL hmo AS DWORD
    LOCAL device$
    LOCAL ret AS DWORD
    LOCAL h AS LONG, v AS LONG
    LOCAL el AS LONG
    LOCAL tt AS DWORD
 '   LOCAL notes() AS BYTE
    LOCAL hpopup AS DWORD
    LOCAL hmenu AS DWORD
    LOCAL item$()
    LOCAL nextt AS DWORD
    LOCAL flipflop AS DWORD

    DIM mins(36)
    DIM maxs(36)
    DIM notes(36)
    DIM currentprograms(122 TO 126)
    ARRAY ASSIGN notes() = 0,40,41,48,49,50,51,52,53,54,55,56,57,58,59,60,61,72,73,74,75,84,85,86,87,76,77,78,79,80,81,82,83,36,37,38,39      'the 0 is a placefiller, as counting from 1 is easier

    hat_readcurrentprograms
    '----- select midi device
    DIM mp(0) AS LOCAL STRING
    GetMidiOutPorts mp()                 ' dll call
    IF ISFALSE midioutGetNumDevs THEN
        MSGBOX "No midi output device found." + $CRLF + "You need a midi device to control <HAT>",,"Calibrate-hat"
        EXIT FUNCTION
    END IF
    'if there's only one device, it's most likely an internal midi device, so auto selecting makes no sense and we rather show the user that just this device is found.
'    IF midioutGetNumDevs = 1 THEN
'        device$ = mp(0)
'        hmo = OpenMidiOutputDevice(0)
'        IF ISFALSE hmo THEN
'            MSGBOX "Failed opening midi output device " + device$ + "." + $CRLF + "Make sure you have a midi output device installed.",,"Calibrate-hat"
'            EXIT FUNCTION
'        END IF
'    ELSE   'choose from multiple devices
        DIALOG NEW 0, "Calibrate <Hat> - Midi device selection.", ,,260, 55, %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_POPUPWINDOW TO hw
            CONTROL ADD LABEL, hw, -1, "Please select a midi output device." + $CRLF + "Make sure that <Hat> is connected to this device and switched on before proceeding.", 1, 1, 258, 24
            CONTROL ADD COMBOBOX, hw, 1, mp(),  1, 26, 258, 80, %CBS_DROPDOWNLIST
            COMBOBOX SELECT hw, 1,1
            CONTROL ADD BUTTON, hw, 2, "Continue", 1, 40, 258, 12, %BS_DEFAULT
            CONTROL SET FOCUS hw, 1
            DIALOG  SET ICON hw, "#1"
        DIALOG SHOW MODAL hw, CALL cbmidiselect TO ret
        IF ISFALSE(ret) THEN EXIT FUNCTION 'window closed with cross
        device$ = mp(ret-1)
        hmo = OpenMidiOutputDevice(ret-1)
        IF ISFALSE hmo THEN
            MSGBOX "Failed opening midi output device " + device$ ,,"Calibrate-hat"
            EXIT FUNCTION
        END IF

'    END IF


'    '----init Hat send program change 127
    Controller %midichan, 66, 127
    ProgChange %midichan, 127

    '----show main window
    DIALOG NEW 0, "Calibrate hat",,,502, 480, %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_POPUPWINDOW TO hw
        MENU NEW BAR TO hmenu
        MENU NEW POPUP TO hpopup
        MENU ADD POPUP, hMenu, "&menu", hPopup, %MF_ENABLED
           MENU ADD STRING, hPopup, "&load settings", 801, %MF_ENABLED
           MENU ADD STRING, hPopup, "&save settings", 802, %MF_ENABLED
           MENU ADD STRING, hpopup, "save settings &as",810, %MF_ENABLED
           MENU ADD STRING, hpopup, "&overview of settings currently uploaded to <Hat>",803, %MF_ENABLED
        MENU ATTACH hMenu, hw


        '* SHAKER


        CONTROL ADD LABEL, hw, -1, "Shaker Left (40 - 41)", 6, 6, 219, 12
            V = 18
            CONTROL ADD CHECKBOX, hw, 1000, "40/41", 10, v, 30, 12
            CONTROL ADD LABEL, hw, -1, "min", 46, v + 1, 15, 12
            CONTROL ADD "msctls_trackbar32", hw, 1100, "min", 63, v + 1, 80, 12, %trstyle' or %TBS_NOTICKS 'OR %TBS_HORZ OR %TBS_NOTICKS OR %TBS_TOOLTIPS
            CONTROL ADD LABEL, hw, -1, "max", 150, v + 1,15, 12
            CONTROL ADD "msctls_trackbar32", hw, 1101, "max", 167, v + 1, 80, 12, %trstyle
            CONTROL ADD CHECKBOX, hw, 1200, "", 249, v, 12, 12



        '* HANDS
        v = v + 25
        CONTROL ADD LABEL, hw, -1, "Left hand (48-51)", 6, v, 219, 12
        CONTROL ADD LABEL, hw, -1, "Right hand (52-55)", 251, v, 219, 12
            FOR i = 0 TO 3
                v = v + 12
                CONTROL ADD CHECKBOX, hw, 3000 + 1000 * i, TRIM$(STR$(48 + i)), 10, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 36, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 3100 + 1000 * i, "min",  53, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 140, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 3101 + 1000 * i, "max", 157, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 3200 + 1000 * i,"", 239, v,12, 12

                CONTROL ADD CHECKBOX, hw, 7000 + 1000 * i, TRIM$(STR$(52 + i)), 260, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 286, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 7100 + 1000 * i, "min",  303, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 390, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 7101 + 1000 * i, "max", 407, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 7200 + 1000 * i,"", 489, v,12, 12

            NEXT

        '* VERTICAL BEATERS
         v = v + 25
         CONTROL ADD LABEL, hw, -1,  "Left vertical beaters (56-58)", 6, v, 219, 12
         CONTROL ADD LABEL, hw, -1,  "Right vertical beaters (59-61)", 251, v, 219, 12
            FOR i = 0 TO 2
                v = v + 12
                CONTROL ADD CHECKBOX, hw, 11000 + 1000 * i, TRIM$(STR$(56 + i)), 10, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 36, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 11100 + 1000 * i, "min",  53, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 140, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 11101 + 1000 * i, "max", 157, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 11200 + 1000 * i,"", 239, v,12, 12

                CONTROL ADD CHECKBOX, hw, 14000 + 1000 * i, TRIM$(STR$(59 + i)), 260, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 286, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 14100 + 1000 * i, "min",  303, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 390, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 14101 + 1000 * i, "max", 407, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 14200 + 1000 * i,"", 489, v,12, 12
            NEXT

        '*upwards beaters
         v = v + 25
         CONTROL ADD LABEL, hw, -1, "Left upward beaters (72-75)", 6, v, 219, 12
         CONTROL ADD LABEL, hw, -1, "Right upward beaters (84-87)", 251, v, 219, 12
            FOR i = 0 TO 3
                v = v + 12
                CONTROL ADD CHECKBOX, hw, 17000 + 1000 * i, TRIM$(STR$(72 + i)), 10, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 36, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 17100 + 1000 * i, "min",  53, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 140, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 17101 + 1000 * i, "max", 157, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 17200 + 1000 * i,"", 239, v,12, 12

                CONTROL ADD CHECKBOX, hw, 21000 + 1000 * i, TRIM$(STR$(84 + i)), 260, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 286, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 21100 + 1000 * i, "min",  303, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 390, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 21101 + 1000 * i, "max", 407, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 21200 + 1000 * i,"", 489, v,12, 12
            NEXT

        '*back beaters
         v = v + 25
         CONTROL ADD LABEL, hw, -1, "Back beaterrs (76-83)", 6, v, 219, 12
            FOR i = 0 TO 3
                v = v + 12
                CONTROL ADD CHECKBOX, hw, 25000 + 1000 * i, TRIM$(STR$(76 + i)), 10, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 36, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 25100 + 1000 * i, "min",  53, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 140, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 25101 + 1000 * i, "max", 157, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 25200 + 1000 * i,"", 239, v,12, 12

                CONTROL ADD CHECKBOX, hw, 29000 + 1000 * i, TRIM$(STR$(80 + i)), 260, v, 20, 12
                CONTROL ADD LABEL, hw, -1, "min", 286, v + 1, 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 29100 + 1000 * i, "min",  303, v+1, 80, 12, %trstyle
                CONTROL ADD LABEL, hw, -1, "max", 390, v , 15, 12
                CONTROL ADD "msctls_trackbar32", hw, 29101 + 1000 * i, "max", 407, v+1, 80, 12, %trstyle
                CONTROL ADD CHECKBOX, hw, 29200 + 1000 * i,"", 489, v,12, 12
            NEXT

         '*pedals
          v = v + 25
          CONTROL ADD LABEL, hw, -1, "Left pedal (36)",6, v, 219, 12
          CONTROL ADD LABEL, hw, -1, "Right pedal (37)",251, v, 219, 12
          v = v + 12
            CONTROL ADD CHECKBOX, hw, 33000, "36", 10, v, 20, 12
            CONTROL ADD LABEL, hw, -1, "min", 36, v, 15, 12
            CONTROL ADD "msctls_trackbar32", hw, 33100, "min", 53, v, 80, 12, %trstyle' or %TBS_NOTICKS 'OR %TBS_HORZ OR %TBS_NOTICKS OR %TBS_TOOLTIPS
            CONTROL ADD LABEL, hw, -1, "max", 140, v,15, 12
            CONTROL ADD "msctls_trackbar32", hw, 33101, "max", 157, v, 80, 12, %trstyle
            CONTROL ADD CHECKBOX, hw, 33200 ,"", 239, v,12, 12

            CONTROL ADD CHECKBOX, hw, 34000, "37",260,v,20,12
            CONTROL ADD LABEL, hw, -1, "min", 286, v, 15, 12
            CONTROL ADD "msctls_trackbar32", hw, 34100, "min", 303, v, 80, 12, %trstyle' or %TBS_NOTICKS 'OR %TBS_HORZ OR %TBS_NOTICKS OR %TBS_TOOLTIPS
            CONTROL ADD LABEL, hw, -1, "max", 390, v,15, 12
            CONTROL ADD "msctls_trackbar32", hw, 34101, "max", 407, v, 80, 12, %trstyle
            CONTROL ADD CHECKBOX, hw, 34200 ,"", 489, v,12, 12

         '*toes
          v = v + 25
          CONTROL ADD LABEL, hw, -1, "Left toe (38)",6, v, 219, 12
          CONTROL ADD LABEL, hw, -1, "Right toe (39)",251, v, 219, 12
          v = v + 12
            CONTROL ADD CHECKBOX, hw, 35000, "38", 10, v, 20, 12
            CONTROL ADD LABEL, hw, -1, "min", 36, v, 15, 12
            CONTROL ADD "msctls_trackbar32", hw, 35100, "min", 53, v, 80, 12, %trstyle' or %TBS_NOTICKS 'OR %TBS_HORZ OR %TBS_NOTICKS OR %TBS_TOOLTIPS
            CONTROL ADD LABEL, hw, -1, "max", 140, v,15, 12
            CONTROL ADD "msctls_trackbar32", hw, 35101, "max", 157, v, 80, 12, %trstyle
            CONTROL ADD CHECKBOX, hw, 35200 ,"", 239, v,12, 12

            CONTROL ADD CHECKBOX, hw, 36000, "39", 260,v,20,12
            CONTROL ADD LABEL, hw, -1, "min", 286, v, 15, 12
            CONTROL ADD "msctls_trackbar32", hw, 36100, "min", 303, v, 80, 12, %trstyle' or %TBS_NOTICKS 'OR %TBS_HORZ OR %TBS_NOTICKS OR %TBS_TOOLTIPS
            CONTROL ADD LABEL, hw, -1, "max", 390, v,15, 12
            CONTROL ADD "msctls_trackbar32", hw, 36101, "max", 407, v, 80, 12, %trstyle
            CONTROL ADD CHECKBOX, hw, 36200 ,"", 489, v,12, 12

          v = v + 25
          CONTROL ADD LABEL, hw, -1, "Program change:", 1, v, 60, 24
          DIM item$(4)
          FOR i = 0 TO 4
              item$(i) = STR$(122 + i)
          NEXT
          CONTROL ADD COMBOBOX, hw, 40100, item$(), 62,v, 50, 80
          COMBOBOX SELECT hw, 40100, 1
          CONTROL ADD BUTTON, hw, 40000, "Upload current settings to <HAT>, program change 122", 116, v,382, 24
          v = v + 37
          CONTROL ADD LABEL, hw, 500, "feedback", 2, v, 496, 28, %SS_SUNKEN

          FOR i = 1000 TO 35000 STEP 1000
              CONTROL SEND hw, i + 100, %TBM_SETRANGE, %TRUE, MAKDWD(1,127)
              CONTROL SEND hw, i + 101, %TBM_SETRANGE, %TRUE, MAKDWD(1,127)
              CONTROL SEND hw, i + 100, %TBM_SETPAGESIZE, 0, 5
              CONTROL SEND hw, i + 101, %TBM_SETPAGESIZE, 0, 5
          NEXT

          DIALOG  SET ICON hw, "#1"

    DIALOG SHOW MODELESS hw, CALL cbMain

    '----main program loop
        tt = 0
    DO
        'cycle through all notes until we find one selected, then play it
        DO
            INCR el
            IF el > 72 THEN el = 1
            IF el <= 36 THEN   'min
                CONTROL GET CHECK hw, 1000 * el  TO i
                IF i THEN
                    tt = 0
                    IF (notes(el) = 40) OR (notes(el) = 41) THEN
                        INCR flipflop  'for shaker..
                        Play %midichan, IIF(BIT(flipflop, 0),40,41), mins(el)
                        CONTROL SET TEXT hw, 500, "*min:" + STR$(IIF(BIT(flipflop, 0),40,41)) + STR$(mins(el))
                    ELSE
                        Play %midichan, notes(el), mins(el)
                        CONTROL SET TEXT hw, 500, "min:" + STR$(notes(el)) + STR$(mins(el))
                    END IF
                    EXIT LOOP
                ELSE
                  '  iterate LOOP
                END IF
            ELSE      'max
                CONTROL GET CHECK hw, 1000 * (el-36) + 200 TO i
                IF i THEN
                    tt = 0
                    IF (notes(el-36) = 40) OR (notes(el-36)=41) THEN
                        INCR flipflop  'for shaker..
                        Play %midichan, IIF(BIT(flipflop, 0),40,41), maxs(el-36)
                        CONTROL SET TEXT hw, 500, "*max:" + STR$(IIF(BIT(flipflop, 0),40,41)) + STR$(maxs(el-36))
                    ELSE
                        Play %midichan, notes(el-36), maxs(el-36)
                        CONTROL SET TEXT hw, 500, "max" + STR$(notes(el-36)) + STR$(maxs(el-36))
                    END IF

                   ' Play %midichan, notes(el-36 )+ IIF(((notes(el-36) = 40) AND BIT(flipflop,0)),1,0), maxs(el-36)
                   EXIT LOOP
                END IF
            END IF
            INCR tt
            IF tt > 72 THEN tt = 0: EXIT LOOP: ITERATE LOOP  'nothing selected..
        LOOP
        DO
            DIALOG DOEVENTS 2 TO ret
            IF timegettime > nextt THEN   'we can't rely on the 'sleep' in dialog doevents for timing..
                nextt = timegettime + 500
                EXIT LOOP
            END IF
        LOOP

    LOOP WHILE ret

    '----cleanup
     ProgChange %midichan, LAstUploadedProg
     controller %midichan, 66, 0
     SLEEP 5
     midioutclose hmo    'is this enough as midi clean up?



END FUNCTION

CALLBACK FUNCTION cbMain
   LOCAL mnmx AS LONG
   LOCAL ret AS DWORD
   LOCAL i AS DWORD
   LOCAL b$
   SELECT CASE CBMSG
       CASE %WM_HSCROLL
           IF ISFALSE changesmade THEN
               changesmade = 1
               DIALOG SET TEXT hw, "Calibrate hat " + IIF$(LEN(currentfilename$), "- preset " + currentfilename, "")   + IIF$(changesmade, "*","")
           END IF
            FOR i = 1000 TO 36000 STEP 1000
               '    b$ = b$ + STR$(GetDlgItem(CBHNDL, i + 100))
               '    b$ = b$ + STR$(GetDlgItem(CBHNDL, i + 101))
               IF CBLPARAM = GetDlgItem(CBHNDL, i + 100) THEN
                   mnmx = 0
                   EXIT FOR
               END IF
               IF CBLPARAM = GetDlgItem(CBHNDL, i + 101) THEN
                   mnmx = 1
                   EXIT FOR
               END IF
           NEXT
           IF i > 36000 THEN
               MSGBOX "invalid slider id!" + STR$(i) + " for cblparam" + STR$(CBLPARAM),,FUNCNAME$
               MSGBOX "check:"+  STR$(GetDlgItem(CBHNDL, 32100)) +  STR$(GetDlgItem(CBHNDL, 32101))
               EXIT FUNCTION
           END IF

       IF ISFALSE(mnmx) THEN   'fill in min
           CONTROL SEND CBHNDL, i + 100, %TBM_GETPOS, 0, 0 TO ret
           mins(i/1000) = ret
         '  CONTROL SET TEXT CBHNDL, 500, "min" + STR$(i) + STR$(mins(i/1000))  + "note: " + STR$(notes(i/1000))
       ELSE   'fill in max
           CONTROL SEND CBHNDL, i + 101, %TBM_GETPOS, 0, 0 TO ret
           maxs(i/1000) = ret
        '   CONTROL SET TEXT CBHNDL, 500, "max" + STR$(i) + STR$(maxs(i/1000))  + "note: " + STR$(notes(i/1000))

       END IF
       CASE %WM_COMMAND
           SELECT CASE CBCTL
               CASE 801
                 '  MSGBOX "to do: load settings"
                  hat_readsettings
                  changesmade = 0
                  DIALOG SET TEXT hw, "Calibrate hat " + IIF$(LEN(currentfilename$), "- preset " + currentfilename, "")  + IIF$(changesmade, "*","")
               CASE 802
                 '  MSGBOX "to do: save settings"
                 IF LEN(currentfilename) THEN
                     hat_writesettings currentfilename
                     changesmade = 0
                     DIALOG SET TEXT hw, "Calibrate hat " + IIF$(LEN(currentfilename$), "- preset " + currentfilename, "")   + IIF$(changesmade, "*","")
                 ELSE
                     hat_writesettings
                     changesmade = 0
                     DIALOG SET TEXT hw, "Calibrate hat " + IIF$(LEN(currentfilename$), "- preset " + currentfilename, "")   + IIF$(changesmade, "*","")
                 END IF
               CASE 810
                 hat_writesettings
                 changesmade = 0
                 DIALOG SET TEXT hw, "Calibrate hat " + IIF$(LEN(currentfilename$), "- preset " + currentfilename, "")  + IIF$(changesmade, "*","")

               CASE 803
                   hat_showcurrentprograms
               CASE 40100
                   COMBOBOX GET TEXT CBHNDL, CBCTL TO b$
                   CONTROL SET TEXT CBHNDL, 40000,"Upload current settings to <HAT>, program change " + b$
               CASE 40000
                   'stop all playing
                   FOR i  = 1 TO 35
                       CONTROL SET CHECK CBHNDL,1000*i , 0
                       CONTROL SET CHECK CBHNDL,1000*i + 200, 0
                   NEXT
                  hat_sendsysex
              '    MSGBOX "to do: send sysex"
           END SELECT
   END SELECT


END FUNCTION

CALLBACK FUNCTION cbmidiselect
    LOCAL i AS DWORD
     IF CBMSG <> %WM_COMMAND THEN EXIT FUNCTION      'let PB handle anything except the continue button..
     IF CBCTL <> 2 THEN EXIT FUNCTION
     IF CBCTLMSG <> %BN_CLICKED THEN EXIT FUNCTION
     COMBOBOX GET SELECT CBHNDL, 1 TO i
     FUNCTION = i
     DIALOG END CBHNDL, i
END FUNCTION

SUB hat_readsettings
    LOCAL fn AS STRING
    LOCAL f AS LONG
    LOCAL i AS LONG
    LOCAL b$
    fn = hat_ofn
    IF ISFALSE LEN(TRIM$(fn)) THEN EXIT SUB
    f = FREEFILE
    OPEN fn FOR INPUT ACCESS READ LOCK WRITE AS f
    IF ERR THEN
        MSGBOX "Failed opening file " + fn + $CRLF + "Error code:" + STR$(ERRCLEAR),,"<Hat>"
        EXIT SUB
    END IF
    i = LBOUND(mins)
    INPUT# f, b$
    'check header
    IF TRIM$(b$) <> "<HAT>" THEN
        MSGBOX fn + " i not a valid <Hat> preset file",,"<Hat>"
        CLOSE f
        EXIT SUB
    END IF
    'read min/max slider values
    DO UNTIL EOF(f)
        INPUT# f, mins(i), maxs(i)     'ths doesn't work?
        INCR i
        IF i > UBOUND(mins) THEN EXIT LOOP
     '   MSGBOX STR$(i) + STR$(mins(i)) + STR$(maxs(i))
    LOOP
    FOR i = LBOUND(mins) TO UBOUND(mins)
         CONTROL SEND hw, i * 1000 + 100, %TBM_SETPOS, 1, mins(i)
         CONTROL SEND hw, i * 1000 + 101, %TBM_SETPOS, 1, maxs(i)
    NEXT
    currentfilename = fn

    CLOSE f

END SUB

SUB hat_writesettings(OPT BYVAL dest AS STRING)
    LOCAL fn AS STRING
    LOCAL f AS LONG
    LOCAL i AS LONG
    IF LEN(TRIM$(dest)) THEN
        fn = dest
    ELSE
        fn = TRIM$(hat_sfn)
    END IF
    IF LCASE$(RIGHT$(fn, 4)) <> ".hat" THEN fn = fn + ".hat"
    IF ISFALSE LEN(TRIM$(fn)) THEN EXIT SUB
    f = FREEFILE
    OPEN fn FOR OUTPUT ACCESS WRITE LOCK WRITE AS f
    IF ERR THEN
        MSGBOX "Failed opening file " + fn + $CRLF + "Preset not saved!" + $CRLF + "Error code:" + STR$(ERRCLEAR),,"<Hat>"
        EXIT SUB
    END IF
    'header
    PRINT# f, "<HAT>"
    'actual values..

    FOR i = LBOUND(mins) TO UBOUND(mins)
        WRITE# f, mins(i), maxs(i)
    NEXT
    currentfilename = fn

    CLOSE f

END SUB

FUNCTION hat_ofn AS STRING
   'basically calls winapi getopenfilename
   LOCAL ofn        AS OPENFILENAME
   LOCAL shortfiln  AS STRING * 28
   LOCAL filnnopath AS STRING * 80
   LOCAL filn       AS STRING * 300
   LOCAL titl       AS STRING * 80
   LOCAL filtr      AS STRING * 200
   LOCAL exts       AS STRING * 3
   LOCAL inidir     AS STRING * 256
   LOCAL origdir     AS STRING * 256
   STATIC inuse AS LONG
   IF inuse THEN EXIT FUNCTION
   inuse = 1
    ofn.lStructSize = SIZEOF(ofn)
    ofn.hwndOwner = 0
 '   ofn.hInstance = @pgh.Inst
    MID$(filn,1) = CHR$(0)
    ofn.lpStrFile = VARPTR(filn)
    ofn.nMaxfile = 300
'    origdir = CURDIR$
'    inidir = "C:\midifiles"
'    CHDIR "C:\midifiles"
    ofn.lpStrInitialDir = VARPTR(inidir)
    filtr =  "<Hat> presets" + CHR$(0) + "*.hat" + CHR$(0) +"all files" + CHR$(0) + "*.*" + CHR$(0,0,0,0)
    ofn.lpStrFilter = VARPTR(filtr)
    ofn.nFilterIndex=1
    titl = "Load Preset"  'title$
    ofn.lpStrTitle= VARPTR(titl)
    ofn.flags = %OFN_FILEMUSTEXIST OR %OFN_LONGNAMES OR %OFN_HIDEREADONLY  OR %OFN_NOCHANGEDIR
    GetOpenFileName ofn
    CHDIR origdir
    FUNCTION = ofn.@lpStrFile
    inuse = 0

END FUNCTION

FUNCTION hat_sfn(OPT BYVAL deft AS STRING)  AS STRING
     LOCAL ofn        AS OPENFILENAME
     LOCAL shortfiln  AS STRING * 28
     LOCAL filnnopath AS STRING * 80
     LOCAL filn       AS STRING * 300
     LOCAL titl       AS STRING * 80
     LOCAL filtr      AS STRING * 200
     LOCAL exts       AS STRING * 3
     LOCAL inidir     AS STRING * 256
     LOCAL start      AS STRING * 80
     ofn.lStructSize = SIZEOF(ofn): ofn.hwndOwner = 0  ': ofn.hInstance = @pgh.Inst
     MID$(filn,1) = CHR$(0)
     ofn.lpStrFile = VARPTR(filn)
     ofn.nMaxfile = 300
  '   origdir = CURDIR$
  '   inidir = TRIM$(origdir) & TRIM$($ConfigDir)                 ' gwr. 21.01.2005
     'inidir = "C:\b\pb\gmt\config":
     'warning TRIM$(inidir), 5000
     CHDIR TRIM$(inidir)
     ofn.lpStrInitialDir = VARPTR(inidir)
     filtr =  "<Hat> preset" + CHR$(0) + "*.hat" + CHR$(0) +"all files" + CHR$(0) + "*.*" + CHR$(0,0,0,0)
     ofn.lpStrFilter = VARPTR(filtr)
     ofn.nFilterIndex=1
     start = deft
     ofn.lpStrfile = VARPTR(start)
     titl = "Save preset"  'title$
     ofn.lpStrTitle= VARPTR(titl)
     ofn.flags = %OFN_LONGNAMES OR %OFN_HIDEREADONLY  OR %OFN_NOCHANGEDIR OR %OFN_ENABLESIZING
     GetSaveFileName ofn
     FUNCTION = ofn.@lpStrfile
END FUNCTION

SUB hat_sendsysex
    LOCAL hwwait AS LONG
    LOCAL i AS LONG , j AS LONG
    LOCAL prog AS BYTE
    LOCAL minvel AS SINGLE, maxvel AS SINGLE, velstep AS SINGLE
    LOCAL valu AS LONG
    LOCAL lsb AS BYTE
    LOCAL msb AS BYTE
    LOCAL sysx$
    LOCAL b$

    '"ask to save here if changed.."
    IF changesmade THEN
        i = MSGBOX ("Do you want to save this settings before sending them to <Hat>?", %MB_YESNOCANCEL, "Calibrate <Hat>")
        SELECT CASE i
            CASE %IDYES:
                currentfilename = hat_sfn(currentfilename)
                hat_writesettings currentfilename: changesmade = 0
            CASE %IDNO  'do nothing
            CASE %IDCANCEL: EXIT SUB
        END SELECT
    END IF


    COMBOBOX GET TEXT hw, 40100  TO b$
    prog = VAL(b$)
    'as for confirmation here?
    DIALOG SHOW STATE hw, %SW_HIDE
    DIALOG NEW hw,"Calibrating <Hat>", 20,80 ,300, 77, %WS_CAPTION TO hwwait
 '   !! eerst vraggen in welke program change hij moet..
    CONTROL ADD LABEL, hwwait, -1, "Sending calibration data to <Hat>, program change " + STR$(prog) + $CRLF +" Don't send any other midi data to <Hat> in the mean time" + $CRLF + _
    "If the sysex is being received well, you should see a green and red led blinking shortly after each other every 3 seconds on the pic boards.", 2, 2, 296, 44
    CONTROL ADD PROGRESSBAR, hwwait, 1, "",  2, 46, 290, 12, %WS_CHILD OR %WS_VISIBLE OR %PBS_SMOOTH
    PROGRESSBAR SET RANGE hwwait, 1, 0, UBOUND(mins)

    DIALOG SHOW MODELESS hwwait

'                   '0xF0              - sysex start
'                '0x7D              - "experimental" manufactorer's ID
'                sysx$ = CHR$(&HF0, &H7D)
'                'pin code
'                sysx$ = sysx$ + pin$
'                'Midi Channel    -
'                sysx$ = sysx$ + CHR$(LOBYT(instrum.channel))
'                'Program number  - remark: program number 0 IS DEFAULT AND non-reprogrammable - 122 tot 127 are programmable
'                sysx$ = sysx$ + CHR$(prog)
'                'Note number
'                sysx$ = sysx$ + CHR$(note)
'                'OX00 Ox00
'                sysx$ = sysx$ + CHR$(0, 0)   'according to johannes cpp code..
    'computer and ssend sysexes
    LOCAL debug$
    mins(2) = mins(1)   'for shaker - same values for both directions
    maxs(2) = maxs(1)
    FOR  i = LBOUND (mins()) + 1 TO UBOUND (mins())
        sysx$ = CHR$(&Hf0, &H7D) + IIF$(notes(i) < 72,"hat ", "cas2") + CHR$(LOBYT(%midichan), prog, notes(i),0,0)
         minvel = 40 + 8 * mins(i)         'actually we'd better consider an even wider mapping.. how did we come to this one in the first place??
         maxvel = 40 + 8 * maxs(i)
         velstep = (maxvel - minvel)/127
'         logfile "**** note" + STR$(notes(i)) + STR$(i) + "minmax:" + STR$(minvel) + STR$(maxvel)
         FOR j = 1 TO 127                'value for each velocity
            valu = minvel + j * velstep
         '   debug$ = debug$ + str$(Velstep)
'              logfile STR$(j) + STR$(valu)
            IF valu > 6000 THEN
                MSGBOX "err - value too high:" + STR$(valu) + "@" +  STR$(i),,FUNCNAME$
                EXIT SUB
            END IF
            lsb = valu AND &H7F
            SHIFT RIGHT valu, 7
            msb = valu AND &H7F
            sysx$ = sysx$ + CHR$(msb, lsb)
         NEXT
         sysx$ = sysx$ + CHR$(&HF7)

        'now send it
        SysEx hMO, sysx$

'         !en dan zenden, progress bar updaten en 3" wachten
         PROGRESSBAR SET POS hwwait, 1, i
         FOR j = 1 TO 30
             DIALOG DOEVENTS 100
         NEXT


    NEXT
  '  msgbox debug$
    IF ISFALSE(changesmade) THEN
        currentprograms(prog) = currentfilename$
    ELSE
        currentprograms(prog) = "<unknown>"
    END IF
    hat_writecurrentprograms
    hat_updatecurrentprograms
    LastUploadedProg = prog
 '   MSGBOX "verder.."

    DIALOG END hwwait
    DIALOG SHOW STATE hw, %SW_SHOW

END SUB

SUB hat_readcurrentprograms
    LOCAL f AS DWORD
    LOCAL i AS LONG
    LOCAL b$
    f = FREEFILE
    OPEN "hat_programs.dat" FOR INPUT ACCESS READ LOCK WRITE  AS f
    DO UNTIL EOF(f)
        LINE INPUT# f, b$
        i = VAL(PARSE$(b$, 1))
        IF i < LBOUND(currentprograms) OR i > UBOUND(currentprograms)  THEN ITERATE LOOP
        currentprograms(i) = PARSE$(b$, 2)
    LOOP
    CLOSE# f
END SUB

SUB hat_writecurrentprograms
    LOCAL f AS DWORD
    LOCAL i AS LONG
    f = FREEFILE
    OPEN "hat_programs.dat" FOR OUTPUT ACCESS WRITE LOCK WRITE AS f
    FOR i = LBOUND(currentprograms) TO UBOUND(currentprograms)
        WRITE# f, i, currentprograms(i)
    NEXT
    CLOSE# f

END SUB

SUB hat_showcurrentprograms
    IF ISFALSE hwProg THEN
        DIALOG NEW hw, "Current <Hat> settings",180,20, 200, 70, %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_POPUPWINDOW OR %WS_THICKFRAME TO hwProg
           CONTROL ADD LISTBOX, hwProg, 1, , 2, 2, 196, 66,  %WS_HSCROLL OR %LBS_DISABLENOSCROLL OR %LBS_NOSEL
           CONTROL SEND hwprog, 1, %LB_SETHORIZONTALEXTENT, 1000, 0

        DIALOG SHOW MODELESS hwprog, CALL CBProg
    END IF
    hat_updatecurrentprograms
END SUB

SUB hat_updatecurrentprograms
    'don't create dialog if it doesn't exist, but otherwise update the info..
    LOCAL i AS LONG
    IF ISFALSE hwProg THEN EXIT SUB
    hat_readcurrentprograms
    LISTBOX RESET hwProg, 1
    FOR i = LBOUND(currentprograms) TO UBOUND(currentprograms)
        LISTBOX ADD hwProg, 1, STR$(i) + ": " + currentprograms(i)
    NEXT

END SUB

CALLBACK FUNCTION CBProg
       LOCAL x AS LONG, y AS LONG
       SELECT CASE CBMSG
           CASE %WM_SIZE
               DIALOG GET SIZE CBHNDL TO x, y
               CONTROL SET SIZE CBHNDL, 1, x-10, y-20
           CASE %WM_CLOSE          'let pb handle the rest
               hwprog = 0
       END SELECT
END FUNCTION




'------ basic midi functions ----------
SUB GetMidiOutPorts (mp() AS STRING) EXPORT
    ' this procedure returns the names of the midi output ports found in the computer as an array of strings.
    LOCAL aantalmidiOUTdevices AS LONG
    LOCAL Caps AS MIDIOUTCAPS
    LOCAL uSize AS LONG
    LOCAL n AS LONG
    aantalmidiOUTdevices = midiOutGetNumDevs ()
    IF aantalmidiOUTdevices <= %False THEN EXIT SUB
    REDIM mp(aantalmidiOUTdevices-1) AS STRING
    uSize = SIZEOF (Caps)
    n = %False
    DO
       midiOutGetDevCaps BYVAL n, Caps, uSize
       mp(n)= Caps.szPName
       INCR n
    LOOP UNTIL n = aantalmidiOUTdevices
END SUB

FUNCTION OpenMidiOutputDevice (BYVAL devicenumber AS LONG) EXPORT AS DWORD
   ' We can use the function to open all available devices and ports.
   ' since we have the midiouthandles in a DLL-global array, all midi-out procedures
   ' are in this DLL.
   LOCAL retval AS DWORD
   LOCAL hmo    AS DWORD
   STATIC init  AS DWORD
tryagain:
   retval = midiOutOpen (hmo, devicenumber, %Null, %Null, %Null)
   SELECT CASE retval
          CASE %MMSYSERR_NOERROR
                     FUNCTION = hmo      ' communicate with caller...
          CASE %MMSYSERR_ALLOCATED
                     IF hmo THEN
                        retval = midiOutClose (hmo)     '04.12.2000
                        GOTO tryagain
                     ELSE
                        ReportMidiError retval
                        FUNCTION = %False
                     END IF
          CASE ELSE
               ReportMidiError retval
               FUNCTION = %False
   END SELECT
END FUNCTION


SUB Controller (BYVAL kanaal AS WORD,BYVAL ctrl?, BYVAL value?) EXPORT
    LOCAL ShortMessage AS LONG
    ShortMessage = value?
    SHIFT LEFT ShortMessage ,8
    ShortMessage = ShortMessage OR ctrl?
    SHIFT LEFT ShortMessage , 8
    ShortMessage = %MEVT_F_SHORT OR ShortMessage OR 176 OR (kanaal AND &H000F)   '&HB0
    midiOutShortMsg hmo, ShortMessage
END SUB

SUB ProgChange(BYVAL kanaal AS WORD,BYVAL value?) EXPORT               ' &HC0  program change    '192
    LOCAL ShortMessage AS LONG
    ShortMessage = ShortMessage OR value?
    SHIFT LEFT ShortMessage , 8
    ShortMessage = %MEVT_F_SHORT OR ShortMessage OR 192 OR (kanaal AND &H000F)
    midiOutShortMsg hmo, ShortMessage
END SUB

SUB Play (BYVAL kanaal AS WORD, BYVAL noot?, BYVAL velo?) EXPORT
    ' low nibble of low byte kanaal = kanaal
    ' low nibble of high byte kanaal = port
    ' highest bit of high byte = UDP/IP
   LOCAL ShortMessage AS LONG
    ShortMessage = velo?
    SHIFT LEFT ShortMessage ,8
    ShortMessage = ShortMessage OR noot?
    SHIFT LEFT ShortMessage , 8
    ShortMessage = %MEVT_F_SHORT OR ShortMessage OR 144 OR (kanaal AND &H000F)
    midiOutShortMsg hmo, ShortMessage
END SUB

SUB SysEx (BYVAL hMidiOut AS DWORD, Sx$) EXPORT
   LOCAL i AS WORD              ' max.64k- this limit is set by the Win32api. Blame Bill Gates...
   LOCAL retval AS DWORD
   LOCAL SysExBuf AS MIDIHDR
   DIM Dta(LEN(Sx$)-1) AS LOCAL BYTE
   FOR i = 0 TO UBOUND(Dta)
       Dta(i)= ASC(MID$(Sx$,i+1,1))
   NEXT i
       SysExBuf.lpData = VARPTR(Dta(0))
       SysExBuf.dwBufferLength = LEN(Sx$)
       SysExBuf.dwFlags = %Null
   retval = MidiOutPrepareHeader (hMidiOut, SysExBuf, SIZEOF(SysExBuf))
   SELECT CASE retval
          CASE %MMSYSERR_NOERROR
                    ' everything works fine... so we send the buffer:
                    MidiOutLongMsg hMidiOut, SysExBuf, SIZEOF(SysExBuf)
          CASE %MMSYSERR_INVALHANDLE
                    MSGBOX "SYSEX-error: Cannot send a sysex if midi-port is not opened",,"Calibrate-Hat Midi error"
          CASE %MMSYSERR_INVALPARAM
                    MSGBOX "SYSEX-error: wrong bufferpointer or size exceeds 64k" ,,"Calibrate-Hat Midi error"
          CASE %MMSYSERR_NOMEM
                    MSGBOX "SYSEX-error: unable to allocate memory",,"Calibrate-Hat Midi error"
   END SELECT
END SUB

SUB ReportMidiError (BYVAL ID AS LONG) EXPORT
     ' used for midi I/O functions
   LOCAL m          AS STRING 'ASCIIZ * 200
   SELECT CASE ID
          CASE %MMSYSERR_NOERROR
               EXIT SUB
          CASE %MMSYSERR_INVALHANDLE
               'The specified device HANDLE is invalid. [unlikely...)
               m = "Invalid device handle for SysEx"  + CHR$(13)
          CASE %MMSYSERR_INVALPARAM
               'The specified address is invalid.       [almost impossible]
               m = "Invalid SYX buffer address" + CHR$(13)
               m = m +  "or, MidiInOpen with invalid pointer or structure" + CHR$(13)
          CASE %MMSYSERR_NOMEM
               'The system is unable TO allocate OR LOCK memory
               m = "Midi Input device started, but... " + CHR$(13)
               m = m + "No memory for SysEx receive buffer." + CHR$(13)
               m = m + "or, unable to allocate memory for midi-input." + CHR$(13)
          CASE %MMSYSERR_BADDEVICEID
               m = "MidiOpen with out of range device ID" + CHR$(13)
          CASE %MMSYSERR_INVALFLAG
               m = "MidiOpen with invalid flags..." + CHR$(13)
   END SELECT
   MSGBOX m,,"Calibrate-Hat Midi error"
END SUB
